#ifndef PROC_SECURE_H
#define PROC_SECURE_H

#include <unistd.h>
#include <linux/flask/flask.h>

extern int execve_secure(const char *filename, 
			 char *const argv[], 
			 char *const envp[], 
			 security_id_t sid);

extern int getsecsid(void);

extern int getosecsid(void);

extern int execl_secure(const char *path, 
			security_id_t sid, 
			const char *arg, ...);

extern int execle_secure (const char *path, 
			  security_id_t sid, 
			  const char *arg, ...);

extern int execlp_secure (const char *file, 
			  security_id_t sid, 
			  const char *arg, ...);

extern int execv_secure (const char *path, 
			 security_id_t sid, 
			 char *const argv[]);

extern int execvp_secure (const char *path, 
			   security_id_t sid, 
			   char *const argv[]);

#endif
